{
   muu TrueColor library for TMT Pascal - Area unit
   Copyright (C) 1999 Tor Arne Gustad (anden@online.no)

   This source code is licensed under the GNU Public License.
   See the GNU General Public License for more details.
}

UNIT mArea;

INTERFACE
{$R-,I+,Q-}

    // Area record
TYPE Area =     RECORD
                  Left,Top,Right,Bottom:    longint;
                END;

// --------------------------------------------------------------------------
FUNCTION Area_rectangle(l,t,r,b:longint): Area;
FUNCTION Area_area(m_area:Area): Area;
FUNCTION Area_maximum(w,h:longint): Area;
    OVERLOAD Area = Area_rectangle;
    OVERLOAD Area = Area_area;
    OVERLOAD Area = Area_maximum;

FUNCTION Area_Width(m_area:Area): longint;
FUNCTION Area_Height(m_area:Area): longint;
  OVERLOAD Width = Area_Width;
  OVERLOAD Height = Area_Height;

IMPLEMENTATION

FUNCTION Area_Width;
  result := m_area.Right-m_area.Left;

FUNCTION Area_Height;
  result := m_area.Bottom-m_area.Top;

// --------------------------------------------------------------------------
FUNCTION Area_rectangle;
BEGIN
  ASM   // all coordinates used in mTC must be sorted before used
    mov  eax, l
    mov  ebx, r
    cmp  eax, ebx
    js   @@next1
    mov  l,   ebx
    mov  r,   eax
  @@next1:
    mov  eax, t
    mov  ebx, b
    cmp  eax, ebx
    js   @@next2
    mov  t,   ebx
    mov  b,   eax
  @@next2:
  END;

  result.Left := l;
  result.Top := t;
  result.Right := r;
  result.Bottom := b;
END;

FUNCTION Area_area;
  result := Area(m_Area.Left,m_Area.Top,m_Area.Right,m_Area.Bottom);

FUNCTION Area_maximum;
  result := Area(0,0,w,h);

// --------------------------------------------------------------------------

end.
